/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the MediaCenterFileVariant type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MediaCenterFileVariant{}

// MediaCenterFileVariant struct for MediaCenterFileVariant
type MediaCenterFileVariant struct {
	Id string `json:"id"`
	Key string `json:"key"`
	ChannelId string `json:"channel_id"`
	MediaFileId string `json:"media_file_id"`
	MediaFile MediaCenterFile `json:"media_file,omitempty"`
	MimeType string `json:"mime_type"`
	Type string `json:"type"`
	StorageId string `json:"storage_id"`
	// Byte size
	Size int32 `json:"size"`
	Width *int32 `json:"width,omitempty"`
	Height *int32 `json:"height,omitempty"`
	Url string `json:"url"`
	ValidFrom *time.Time `json:"valid_from,omitempty"`
	ValidUntil *time.Time `json:"valid_until,omitempty"`
	CreatedAt time.Time `json:"created_at"`
	FallbackLanguage *string `json:"fallback_language,omitempty"`
	Translations []MediaCenterTranslation `json:"translations,omitempty"`
}

// NewMediaCenterFileVariant instantiates a new MediaCenterFileVariant object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMediaCenterFileVariant(id string, key string, channelId string, mediaFileId string, mimeType string, type_ string, storageId string, size int32, url string, createdAt time.Time) *MediaCenterFileVariant {
	this := MediaCenterFileVariant{}
	this.Id = id
	this.Key = key
	this.ChannelId = channelId
	this.MediaFileId = mediaFileId
	this.MimeType = mimeType
	this.Type = type_
	this.StorageId = storageId
	this.Size = size
	this.Url = url
	this.CreatedAt = createdAt
	return &this
}

// NewMediaCenterFileVariantWithDefaults instantiates a new MediaCenterFileVariant object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMediaCenterFileVariantWithDefaults() *MediaCenterFileVariant {
	this := MediaCenterFileVariant{}
	return &this
}

// GetId returns the Id field value
func (o *MediaCenterFileVariant) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *MediaCenterFileVariant) SetId(v string) {
	o.Id = v
}

// GetKey returns the Key field value
func (o *MediaCenterFileVariant) GetKey() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Key
}

// GetKeyOk returns a tuple with the Key field value
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetKeyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Key, true
}

// SetKey sets field value
func (o *MediaCenterFileVariant) SetKey(v string) {
	o.Key = v
}

// GetChannelId returns the ChannelId field value
func (o *MediaCenterFileVariant) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *MediaCenterFileVariant) SetChannelId(v string) {
	o.ChannelId = v
}

// GetMediaFileId returns the MediaFileId field value
func (o *MediaCenterFileVariant) GetMediaFileId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MediaFileId
}

// GetMediaFileIdOk returns a tuple with the MediaFileId field value
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetMediaFileIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MediaFileId, true
}

// SetMediaFileId sets field value
func (o *MediaCenterFileVariant) SetMediaFileId(v string) {
	o.MediaFileId = v
}

// GetMediaFile returns the MediaFile field value if set, zero value otherwise.
func (o *MediaCenterFileVariant) GetMediaFile() MediaCenterFile {
	if o == nil || IsNil(o.MediaFile) {
		var ret MediaCenterFile
		return ret
	}
	return o.MediaFile
}

// GetMediaFileOk returns a tuple with the MediaFile field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetMediaFileOk() (MediaCenterFile, bool) {
	if o == nil || IsNil(o.MediaFile) {
		return MediaCenterFile{}, false
	}
	return o.MediaFile, true
}

// HasMediaFile returns a boolean if a field has been set.
func (o *MediaCenterFileVariant) HasMediaFile() bool {
	if o != nil && !IsNil(o.MediaFile) {
		return true
	}

	return false
}

// SetMediaFile gets a reference to the given MediaCenterFile and assigns it to the MediaFile field.
func (o *MediaCenterFileVariant) SetMediaFile(v MediaCenterFile) {
	o.MediaFile = v
}

// GetMimeType returns the MimeType field value
func (o *MediaCenterFileVariant) GetMimeType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MimeType
}

// GetMimeTypeOk returns a tuple with the MimeType field value
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetMimeTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MimeType, true
}

// SetMimeType sets field value
func (o *MediaCenterFileVariant) SetMimeType(v string) {
	o.MimeType = v
}

// GetType returns the Type field value
func (o *MediaCenterFileVariant) GetType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *MediaCenterFileVariant) SetType(v string) {
	o.Type = v
}

// GetStorageId returns the StorageId field value
func (o *MediaCenterFileVariant) GetStorageId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.StorageId
}

// GetStorageIdOk returns a tuple with the StorageId field value
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetStorageIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.StorageId, true
}

// SetStorageId sets field value
func (o *MediaCenterFileVariant) SetStorageId(v string) {
	o.StorageId = v
}

// GetSize returns the Size field value
func (o *MediaCenterFileVariant) GetSize() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Size
}

// GetSizeOk returns a tuple with the Size field value
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetSizeOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Size, true
}

// SetSize sets field value
func (o *MediaCenterFileVariant) SetSize(v int32) {
	o.Size = v
}

// GetWidth returns the Width field value if set, zero value otherwise.
func (o *MediaCenterFileVariant) GetWidth() int32 {
	if o == nil || IsNil(o.Width) {
		var ret int32
		return ret
	}
	return *o.Width
}

// GetWidthOk returns a tuple with the Width field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetWidthOk() (*int32, bool) {
	if o == nil || IsNil(o.Width) {
		return nil, false
	}
	return o.Width, true
}

// HasWidth returns a boolean if a field has been set.
func (o *MediaCenterFileVariant) HasWidth() bool {
	if o != nil && !IsNil(o.Width) {
		return true
	}

	return false
}

// SetWidth gets a reference to the given int32 and assigns it to the Width field.
func (o *MediaCenterFileVariant) SetWidth(v int32) {
	o.Width = &v
}

// GetHeight returns the Height field value if set, zero value otherwise.
func (o *MediaCenterFileVariant) GetHeight() int32 {
	if o == nil || IsNil(o.Height) {
		var ret int32
		return ret
	}
	return *o.Height
}

// GetHeightOk returns a tuple with the Height field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetHeightOk() (*int32, bool) {
	if o == nil || IsNil(o.Height) {
		return nil, false
	}
	return o.Height, true
}

// HasHeight returns a boolean if a field has been set.
func (o *MediaCenterFileVariant) HasHeight() bool {
	if o != nil && !IsNil(o.Height) {
		return true
	}

	return false
}

// SetHeight gets a reference to the given int32 and assigns it to the Height field.
func (o *MediaCenterFileVariant) SetHeight(v int32) {
	o.Height = &v
}

// GetUrl returns the Url field value
func (o *MediaCenterFileVariant) GetUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Url
}

// GetUrlOk returns a tuple with the Url field value
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Url, true
}

// SetUrl sets field value
func (o *MediaCenterFileVariant) SetUrl(v string) {
	o.Url = v
}

// GetValidFrom returns the ValidFrom field value if set, zero value otherwise.
func (o *MediaCenterFileVariant) GetValidFrom() time.Time {
	if o == nil || IsNil(o.ValidFrom) {
		var ret time.Time
		return ret
	}
	return *o.ValidFrom
}

// GetValidFromOk returns a tuple with the ValidFrom field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetValidFromOk() (*time.Time, bool) {
	if o == nil || IsNil(o.ValidFrom) {
		return nil, false
	}
	return o.ValidFrom, true
}

// HasValidFrom returns a boolean if a field has been set.
func (o *MediaCenterFileVariant) HasValidFrom() bool {
	if o != nil && !IsNil(o.ValidFrom) {
		return true
	}

	return false
}

// SetValidFrom gets a reference to the given time.Time and assigns it to the ValidFrom field.
func (o *MediaCenterFileVariant) SetValidFrom(v time.Time) {
	o.ValidFrom = &v
}

// GetValidUntil returns the ValidUntil field value if set, zero value otherwise.
func (o *MediaCenterFileVariant) GetValidUntil() time.Time {
	if o == nil || IsNil(o.ValidUntil) {
		var ret time.Time
		return ret
	}
	return *o.ValidUntil
}

// GetValidUntilOk returns a tuple with the ValidUntil field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetValidUntilOk() (*time.Time, bool) {
	if o == nil || IsNil(o.ValidUntil) {
		return nil, false
	}
	return o.ValidUntil, true
}

// HasValidUntil returns a boolean if a field has been set.
func (o *MediaCenterFileVariant) HasValidUntil() bool {
	if o != nil && !IsNil(o.ValidUntil) {
		return true
	}

	return false
}

// SetValidUntil gets a reference to the given time.Time and assigns it to the ValidUntil field.
func (o *MediaCenterFileVariant) SetValidUntil(v time.Time) {
	o.ValidUntil = &v
}

// GetCreatedAt returns the CreatedAt field value
func (o *MediaCenterFileVariant) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *MediaCenterFileVariant) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetFallbackLanguage returns the FallbackLanguage field value if set, zero value otherwise.
func (o *MediaCenterFileVariant) GetFallbackLanguage() string {
	if o == nil || IsNil(o.FallbackLanguage) {
		var ret string
		return ret
	}
	return *o.FallbackLanguage
}

// GetFallbackLanguageOk returns a tuple with the FallbackLanguage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetFallbackLanguageOk() (*string, bool) {
	if o == nil || IsNil(o.FallbackLanguage) {
		return nil, false
	}
	return o.FallbackLanguage, true
}

// HasFallbackLanguage returns a boolean if a field has been set.
func (o *MediaCenterFileVariant) HasFallbackLanguage() bool {
	if o != nil && !IsNil(o.FallbackLanguage) {
		return true
	}

	return false
}

// SetFallbackLanguage gets a reference to the given string and assigns it to the FallbackLanguage field.
func (o *MediaCenterFileVariant) SetFallbackLanguage(v string) {
	o.FallbackLanguage = &v
}

// GetTranslations returns the Translations field value if set, zero value otherwise.
func (o *MediaCenterFileVariant) GetTranslations() []MediaCenterTranslation {
	if o == nil || IsNil(o.Translations) {
		var ret []MediaCenterTranslation
		return ret
	}
	return o.Translations
}

// GetTranslationsOk returns a tuple with the Translations field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MediaCenterFileVariant) GetTranslationsOk() ([]MediaCenterTranslation, bool) {
	if o == nil || IsNil(o.Translations) {
		return nil, false
	}
	return o.Translations, true
}

// HasTranslations returns a boolean if a field has been set.
func (o *MediaCenterFileVariant) HasTranslations() bool {
	if o != nil && !IsNil(o.Translations) {
		return true
	}

	return false
}

// SetTranslations gets a reference to the given []MediaCenterTranslation and assigns it to the Translations field.
func (o *MediaCenterFileVariant) SetTranslations(v []MediaCenterTranslation) {
	o.Translations = v
}

func (o MediaCenterFileVariant) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MediaCenterFileVariant) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["key"] = o.Key
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["media_file_id"] = o.MediaFileId
	if !IsNil(o.MediaFile) {
		toSerialize["media_file"] = o.MediaFile
	}
	toSerialize["mime_type"] = o.MimeType
	toSerialize["type"] = o.Type
	toSerialize["storage_id"] = o.StorageId
	toSerialize["size"] = o.Size
	if !IsNil(o.Width) {
		toSerialize["width"] = o.Width
	}
	if !IsNil(o.Height) {
		toSerialize["height"] = o.Height
	}
	toSerialize["url"] = o.Url
	if !IsNil(o.ValidFrom) {
		toSerialize["valid_from"] = o.ValidFrom
	}
	if !IsNil(o.ValidUntil) {
		toSerialize["valid_until"] = o.ValidUntil
	}
	toSerialize["created_at"] = o.CreatedAt
	if !IsNil(o.FallbackLanguage) {
		toSerialize["fallback_language"] = o.FallbackLanguage
	}
	if !IsNil(o.Translations) {
		toSerialize["translations"] = o.Translations
	}
	return toSerialize, nil
}

type NullableMediaCenterFileVariant struct {
	value *MediaCenterFileVariant
	isSet bool
}

func (v NullableMediaCenterFileVariant) Get() *MediaCenterFileVariant {
	return v.value
}

func (v *NullableMediaCenterFileVariant) Set(val *MediaCenterFileVariant) {
	v.value = val
	v.isSet = true
}

func (v NullableMediaCenterFileVariant) IsSet() bool {
	return v.isSet
}

func (v *NullableMediaCenterFileVariant) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMediaCenterFileVariant(val *MediaCenterFileVariant) *NullableMediaCenterFileVariant {
	return &NullableMediaCenterFileVariant{value: val, isSet: true}
}

func (v NullableMediaCenterFileVariant) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMediaCenterFileVariant) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


